package sun.awt;

import java.awt.AWTEvent;
import java.awt.EventQueue;

public class EventQueueDelegate
{
    private static final Object EVENT_QUEUE_DELEGATE_KEY;
    
    public EventQueueDelegate() {
    }
    
    public static void setDelegate(EventQueueDelegate.Delegate delegate) {
        AppContext.getAppContext().put(EventQueueDelegate.EVENT_QUEUE_DELEGATE_KEY, delegate);
    }
    
    public static EventQueueDelegate.Delegate getDelegate() {
        return (EventQueueDelegate.Delegate)AppContext.getAppContext().get(EventQueueDelegate.EVENT_QUEUE_DELEGATE_KEY);
    }
    
    static {
        EVENT_QUEUE_DELEGATE_KEY = new StringBuilder("EventQueueDelegate.Delegate");
    }
    
    public interface Delegate
    {
        public abstract AWTEvent getNextEvent(EventQueue p0) throws InterruptedException;
        
        public abstract Object beforeDispatch(AWTEvent p0) throws InterruptedException;
        
        public abstract void afterDispatch(AWTEvent p0, Object p1) throws InterruptedException;
    }
}
